import Taro, { Component } from '@tarojs/taro';
import './index.scss'
import ready from '@/utils/ready'
import { savePoint, updatePoint, queryExtContents, queryIndexIcons } from '@/services/common'
import { reportIndexCustomer } from '@/services/project'
import { queryHelpGroup } from '@/services/news'
import { getIndexShare } from '@/services/user'
import { GetShopList } from '@/services/shop'
import { dispatchCitySelected } from '@/actions/city'
import { SET_SCREEN_SHOWED } from '@/constants/project'
import { getStore, connect } from '@tarojs/redux'
import * as actions from '@/actions/project'
import { ROLE_CODE } from '@/constants/user'
import { share as shareSavePoint } from '@/utils/shareSavePoint'
import { transferImage } from '@/utils/tools'
import ShopItem from '../league/item'
import BannerTwo from '../project/swiper'
import { View } from '@tarojs/components';

@connect(
  state => ({ ...state.project, ...state.city, ...state.user, system: state.system }),
  { ...actions, dispatchCitySelected }
)
export default class Index extends Component {
  config = {
    navigationBarTitleText: '雅乐集'
  }
  state = {
    TestImg: 'https://timgsa.baidu.com/timg?image&quality=80&size=b9999_10000&sec=1604566584132&di=33926cb8407ae341fa1d8cc0d322d392&imgtype=0&src=http%3A%2F%2Fattach.bbs.miui.com%2Fforum%2F201305%2F30%2F220025pxfkhykvkgkvuktq.jpg',
    BannerData: [
      { id: 1, img: 'https://timgsa.baidu.com/timg?image&quality=80&size=b9999_10000&sec=1604485078843&di=e50cb70de152bb6b83f7b1d712b509c8&imgtype=0&src=http%3A%2F%2Fattachments.gfan.com%2Fforum%2F201503%2F19%2F211608ztcq7higicydxhsy.jpg' },
      { id: 2, img: 'https://timgsa.baidu.com/timg?image&quality=80&size=b9999_10000&sec=1604486077351&di=a5320b0e8f2dd45ccdee71f7e1a541d5&imgtype=0&src=http%3A%2F%2Fbenyouhuifile.it168.com%2Fforum%2F201304%2F06%2F11435052yrezzae1bua8ee.jpg' },
      { id: 3, img: 'https://timgsa.baidu.com/timg?image&quality=80&size=b9999_10000&sec=1604486077351&di=ba0b2021b0dce8807b75bcd81cd44d32&imgtype=0&src=http%3A%2F%2Fbenyouhuifile.it168.com%2Fforum%2Fday_100429%2F1004291840008539c8ac02cd5c.jpg' },
      { id: 4, img: 'https://timgsa.baidu.com/timg?image&quality=80&size=b9999_10000&sec=1604486077351&di=014ef8ce837f8762c1e982f093286f42&imgtype=0&src=http%3A%2F%2Fattach.bbs.miui.com%2Fforum%2F201306%2F23%2F110328s72xxse7lfis9fnd.jpg' },
      { id: 5, img: 'https://timgsa.baidu.com/timg?image&quality=80&size=b9999_10000&sec=1604486077349&di=861dfd8adb91ede1c5f6de5abb59638b&imgtype=0&src=http%3A%2F%2Fattach.bbs.miui.com%2Fforum%2F201205%2F15%2F152011zser9o5oa9ee9xx6.jpg' }
    ],
    StoreList: [],
    NavList: [
      { id: 1, img: require('@/assets/img/icon1.png'), name: '雅居宝', router: null },
      { id: 2, img: require('@/assets/img/icon2.png'), name: '乐粉福利', router: `/pages/shop/index` },
      { id: 3, img: require('@/assets/img/icon3.png'), name: '乐趣头条', router: `/pages/activity/activity` },
      { id: 4, img: require('@/assets/img/icon4.png'), name: '乐客联盟', router: `/pages/league/index` }
    ],
    maskVisible: false,
    keywords: '',
    loaded: false,
    maskBanner: '',
    shareImg: '',
    imgDocument: '',
    newImg: '',
    // adImage: advImageOfApp,
    bannerList: [],
    helpGroupList: [],
    activityList: [],
    recordId: null,
    visBanner: false,
    visPropagandaBanner: false,
    indicatorDots: false,
    vertical: true,
    achieve: false,
    propagandaBanner: [],
    newsShow: false,
    city: null,
    iconList: [],
    CityData: null,
    BuildingList: []
  }
  componentWillMount () {
    ready.queue(() => {
      const city = this.state.city || this.props.curCity
      this.setState({
        CityData: city
      }, () => {
        this.loadData({ curCity: city })
        this.getIndexShareInfo()
        savePoint({
          event: 'index',
          eventType: 'main',
          propertyName: '进入首页',
          data: '{}'
        }).then(res => {
          this.setState({
            recordId: res.recordId
          })
        })
        GetShopList({ pageNum: 1, pageSize: 10, isIndex: true, sortField: 'sort_no' }).then((res) => {
          let Arr = res.records || []
          let aArr = []
          Arr.map((item) => {
            aArr.push({ ...item, badges: (item.badges || '').split(',') || [], lng: item.lngLat.split(',')[0], lat: item.lngLat.split(',')[1] })
          })
          this.setState({
            StoreList: aArr || []
          })
        })
      })
    })
  }
  getIndexIcons () {
    queryIndexIcons().then(res => {
      if (res && res.length) {
        this.setState({ iconList: res })
      }
    })
  }
  getIndexShareInfo () {
    getIndexShare().then(res => {
      const shareInfo = (res || []).filter(item => item.imgType === 'index')[0]
      const newsInfo = (res || []).filter(item => item.imgType === 'indexNews')[0]
      this.setState({
        shareImg: (shareInfo || {}).imgUrl,
        imgDocument: (shareInfo || {}).imgDocument,
        newImg: (newsInfo || {}).imgUrl,
      })
    })
  }
  toChatList () {
    Taro.navigateTo({
      url: '/pages/im/list/index'
    })
  }
  componentDidShow () {
    const city = this.state.city || this.props.curCity
    if (city && city.id) {
      ready.queue(() => {
        this.loadData({ curCity: city })
      })
    }
  }
  componentWillUnmount () {
    const { recordId } = this.state
    recordId && updatePoint(recordId)
  }
  loadData (props = {}) {
    this.loadHelpGroupList(props)
    this.loadList(props)
    this.loadExtContents(props)
    this.getIndexIcons()
    this.report()

  }
  report () {
    const consultant = this.$router.params.consultant || Taro.getStorageSync('consultantId') || ''
    const recommender = this.$router.params.recommender || Taro.getStorageSync('recommender') || ''
    const loadOptions = wx.getLaunchOptionsSync()
    reportIndexCustomer({ channelId: '', qrCodeId: '', scene: loadOptions.scene, showToast: false }, { ['x-consultant']: consultant, ['x-recommender']: recommender })

  }
  loadExtContents (props) {
    const curCity = this.state.city || props.curCity
    this.setState({
      visBanner: false,
      visPropagandaBanner: false
    })
    queryExtContents({ cityId: curCity.id }).then(res => {
      // 开屏广告
      const maskBanner = (res || []).filter(x => x.showType === 'screen' && x.showPosition === 'index')[0] || {}
      const maskVisible = maskBanner.contentId && this.props.screenShow !== maskBanner.contentId

      // 首页 banner
      const bannerList = (res || []).filter(x => x.showType === 'banner' && x.showPosition === 'index')

      // 首页 宣传位
      const propagandaBanner = (res || []).filter(x => x.showType === 'propaganda')

      this.setState({
        maskVisible,
        visBanner: true,
        visPropagandaBanner: true,
        maskBanner,
        bannerList,
        propagandaBanner,
      }, () => {
        if (Taro.getStorageSync('firstLoading') != '8') {
          const { dispatch } = getStore()
          dispatch({ type: SET_SCREEN_SHOWED, payload: maskBanner.contentId })
        } else {
          Taro.setStorageSync('firstLoading', '6')
        }
      })
    })
  }
  loadHelpGroupList (props) {
    const curCity = this.state.city || props.curCity
    queryHelpGroup({ cityId: curCity.id, buildingId: '' }).then(res => {
      this.setState({
        helpGroupList: res || []
      })
    })
  }
  loadList (props) {
    const { keywords } = this.state
    const curCity = this.state.city || props.curCity
    const payload = { name: keywords, pageSize: 10 }
    if (curCity.id) {
      payload.cityId = curCity.id
    }
    Taro.showLoading()
    this.props.dispatchIndexProjects(payload).then(res => {
      if (res.records.length) {
        this.setState({
          BuildingList: res.records
        })
      }
      if (!this.state.loaded && res.records.length <= 0) {
        Taro.showToast({
          title: '当前城市暂无楼盘',
          icon: 'none'
        })
      }
      Taro.hideLoading()
      this.setState({
        loaded: true
      })
      if (!this.state.maskVisible) {
        Taro.showTabBar()
      }
    })
  }
  //   转发
  onShareAppMessage = () => {
    const { userInfo: { person: { personId, personType, userId } } } = this.props
    const consultant1 = this.$router.params.consultant || Taro.getStorageSync('consultantId') || ''
    const consultantId1 = this.$router.params.consultantId || ''
    const consultant = personType == ROLE_CODE["CONSULTANT"] ? personId : consultant1
    const consultantId = personType == ROLE_CODE["CONSULTANT"] ? userId : consultantId1
    shareSavePoint({
      event: 'share',
      eventType: 'main',
      propertyName: '首页分享',
      sharePersonId: personId,
      targetId: 'index',
      data: '{}'
    }, 'main').then(res => {
      // console.log('首页分享')
    })
    // console.log('Indexrouter--->', `/pages/project/index?from=share&recommender=${personId}&consultant=${consultant}&consultantId=${consultantId}&id=index`)
    return {
      title: this.state.imgDocument || ` 精准获客—上${this.props.userInfo.miniApp.name || '致云'}，买好房`,//分享内容
      path: `/pages/index/index?from=share&recommender=${personId}&consultant=${consultant}&consultantId=${consultantId}&id=index`,//分享地址
      imageUrl: this.state.shareImg || 'https://njcj.oss-cn-shanghai.aliyuncs.com/miniapp/upload/images/1574145199853-97feda7895c65be33aa234a7b81b37f.jpg',
    }
  }
  onViewDetail (item) {
    Taro.navigateTo({
      url: `/pages/project/detail/index?id=${item.buildingId}`
    })
  }
  handlePropagandaClick = (item) => {
    if (item.contentType && item.contentType != "nothing") {
      this.redirectTo(item)
    } else {
      // console.log(item, "item")
    }
  }
  handleBannerClick = (item) => {
    if (item.contentType && item.contentType != "nothing") {
      this.redirectTo(item)
    } else {
      // console.log(item, "item")
    }
  }
  redirectTo ({ targetId, contentType, buildingId } = {}) {
    switch (contentType) {
      // 项目
      case 'project':
        Taro.navigateTo({
          url: '/pages/project/detail/index?id=' + buildingId
        })
        return;

      // 活动
      case 'activity':
        Taro.navigateTo({
          url: '/pages/activity/detail/index?id=' + targetId
        })
        return;

      // 助力
      case 'help':
        Taro.navigateTo({
          url: '/pages/activity/detail/assistance?id=' + targetId
        })
        return;

      // 拼团
      case 'group':
        Taro.navigateTo({
          url: '/pages/activity/detail/assemble?id=' + targetId
        })
        return;

      // 资讯
      case 'news':
        Taro.navigateTo({
          url: '/pages/news/detail/index?id=' + targetId
        })
        return;
      // h5
      case 'h5':
        Taro.navigateTo({
          url: '/pages/project/h5Page?id=' + targetId
        })
        return;
      // live
      case 'live':
        Taro.navigateTo({
          url: '/onlineSelling/pages/live/index?id=' + targetId
        })
        return;
      // salesBatch
      case 'salesBatch':
        Taro.navigateTo({
          url: `/onlineSelling/pages/houseList/index?id=${targetId}`
        })
        return;

      // 其他
      case 'others':
      default:
        this.handleMaskClose()
        return;
    }
  }
  handleHelpGroupClick (item) {
    if (item.type == 1) {
      Taro.navigateTo({
        url: '/pages/activity/detail/assistance?id=' + item.activityId
      })
    } else {
      Taro.navigateTo({
        url: '/pages/activity/detail/assemble?id=' + item.activityId
      })
    }
  }
  handleMaskClose () {
    this.setState({
      maskVisible: false
    })
    Taro.showTabBar()
  }
  makePhoneCall = () => {
    Taro.makePhoneCall({
      phoneNumber: '0772-6861111'
    })
    savePoint({
      event: 'phone',
      eventType: 'main',
      propertyName: '点击电话咨询',
      data: '{}'
    }).then(res => {
      // console.log('点击电话咨询')
    })
  }
  handleMaskBannerClick (data) {
    this.redirectTo(data)
  }
  handleLocationClick () {
    Taro.navigateTo({
      url: `/pages/city/index`
    })
  }
  handleToHouseList () {
    Taro.navigateTo({
      url: '/pages/project/list/index'
    })
  }
  handleProItemClick () {
    Taro.navigateTo({
      url: '/pages/project/list/index'
    })
  }
  toRecomonedPage () {
    Taro.navigateTo({
      url: `/useless/pages/agent/recommend/index?type=index&cityId=` + this.props.curCity.id
    })

  }
  toMapHouse () {
    Taro.navigateTo({
      url: `/pages/project/map/index`
    })
  }
  handleAuthPhoneSuccess (curCity) {
    Taro.navigateTo({
      url: `/useless/pages/agent/recommend/index?type=index&cityId=` + curCity.id
    })
  }
  handleItemClick (item) {
    switch (item.type) {
      case 'help':
        Taro.navigateTo({
          url: '/pages/activity/detail/assistance?id=' + item.activityId
        })
        return
      case 'group':
        Taro.navigateTo({
          url: '/pages/activity/detail/assemble?id=' + item.activityId
        })
        return
      default:
        Taro.navigateTo({
          url: '/pages/activity/detail/index?id=' + item.activityId
        })
        return
    }
  }
  ToBuildingList () {
    Taro.navigateTo({
      url: '/pages/project/list/index'
    })
  }
  NavClick (item) {
    if (item.router !== null) {
      Taro.navigateTo({
        url: item.router
      })
    } else {
      Taro.showToast({
        title: '敬请期待',
        icon: 'none'
      })
    }
  }
  render () {
    const { NavList, StoreList, bannerList, CityData, helpGroupList, BuildingList, propagandaBanner } = this.state
    return (
      <View className='Page'>

        {/* banner区域 */}
        <View className='BannerContainer'>

          {/* banner */}
          <View className='Banner'>
            <View>
              <View>
                <View className='DingWei' onClick={this.handleLocationClick}>
                  <Image mode='widthFix' src={require('@/assets/img/icon5.png')} />
                  <Text>{CityData !== null ? CityData.name : '正在定位...'}</Text>
                </View>
                <Swiper className='Swiper' indicatorColor='rgba(0,0,0,0.4)' indicatorActiveColor='#fff' circular indicatorDots autoplay>
                  {
                    bannerList.length &&
                    bannerList.map((item, index) => (
                      <SwiperItem key={`Swiper-${index}`} onClick={this.handleBannerClick.bind(this, item)}>
                        <Image mode='widthFix' className='centerLabel' src={item.image} />
                      </SwiperItem>
                    ))
                  }
                </Swiper>
              </View>
            </View>
          </View>

          {/* nav */}
          <View className='Nav flex-h'>
            {
              NavList.map((item, index) => (
                <View className='flex-item' onClick={this.NavClick.bind(this, item)} key={`Nav-${index}`}>
                  <View>
                    <Image mode='heightFix' className='centerLabel' src={item.img} />
                  </View>
                  <Text>{item.name}</Text>
                </View>
              ))
            }
          </View>

        </View>

        {/* 热门活动推荐 */}
        {
          helpGroupList && helpGroupList.length &&
          <View className='ActivityRecommed'>
            <Text className='Title'>热门活动推荐</Text>
            <View>
              <View>
                <Swiper className='Swiper' indicatorColor='rgba(0,0,0,0.4)' indicatorActiveColor='#fff' circular indicatorDots autoplay>
                  {
                    propagandaBanner.length &&
                    propagandaBanner.map((item, index) => (
                      <SwiperItem key={`Swiper-${index}`} onClick={this.handleBannerClick.bind(this, item)}>
                        <Image mode='widthFix' className='centerLabel' src={item.image} />
                      </SwiperItem>
                    ))
                  }
                </Swiper>
              </View>
              {/* <Image mode='widthFix' className='centerLabel' src={transferImage(helpGroupList[0].bannerListImg)} onClick={this.handleItemClick.bind(this, item)} /> */}
            </View>
          </View>
        }

        {/* 精品楼盘大搜罗 */}
        {
          BuildingList && BuildingList.length &&
          <View className='HousesRecommed'>
            <View className='Title' onClick={this.ToBuildingList}>
              <Text>精品楼盘大搜罗</Text>
              <Image mode='widthFix' src={require('@/assets/img/more2.png')} />
            </View>
            <View className='Content' onClick={this.onViewDetail.bind(this, BuildingList[0])}>
              <Image mode='widthFix' className='centerLabel' src={transferImage(BuildingList[0].buildingListImg[0].url)} />
              <Text>{BuildingList[0].name}</Text>
            </View>
          </View>
        }

        {/* 乐客商家 */}
        <View className='LeKeStore'>
          <Text className='ListTitle'>乐客商家</Text>
          {
            StoreList.map((item, index) => (
              <View>
                <ShopItem item={item} lat={CityData.lat} lng={CityData.lng} key={`Store-${index}`}></ShopItem>
                <View className='Line'></View>
              </View>
            ))
          }
        </View>

      </View>
    )
  }
}
