import { View } from '@tarojs/components'
import { Component } from '@tarojs/taro'
import './index.scss'

export default class Index extends Component {
  config = {
    navigationBarTitleText: '商家名称'
  }
  state = {
  }
  distance (la1, lo1, la2, lo2) {
    let La1 = la1 * Math.PI / 180.0
    let La2 = la2 * Math.PI / 180.0
    let La3 = La1 - La2
    let Lb3 = lo1 * Math.PI / 180.0 - lo2 * Math.PI / 180.0
    let s = 2 * Math.asin(Math.sqrt(Math.pow(Math.sin(La3 / 2), 2) + Math.cos(La1) * Math.cos(La2) * Math.pow(Math.sin(Lb3 / 2), 2)))
    s = s * 6378.137
    s = Math.round(s * 10000) / 10000
    return s.toFixed(1)
  }
  render () {
    const { lat, lng, item } = this.props
    return (
      <Navigator className='ShopItem flex-h' url={`/pages/league/detail?id=${item.shopId}`}>
        <View className='Img'>
          <Image mode='aspectFill' className='centerLabel' src={item.shopLogo} />
        </View>
        <View className='flex-item'>
          <View>
            <View className='Title'>
              <Text className='Name'>{item.shopName}</Text>
              {
                item.badges.map((subItem, subIndex) => (
                  <Text className={subItem === '买' ? 'Label Type1' : subItem === '订' ? 'Label Type2' : subItem === '外' ? 'Label Type3' : 'Label Type4'} key={`Tag-${subIndex}`}>{subItem}</Text>
                ))
              }
            </View>
            <View className='Score'>
              {
                item.score - 0 > 0 ?
                  <Image mode='widthFix' src={require('@/assets/img/icon6.png')} />
                  :
                  <Image mode='widthFix' src={require('@/assets/img/icon7.png')} />
              }
              {
                item.score - 0 > 1 ?
                  <Image mode='widthFix' src={require('@/assets/img/icon6.png')} />
                  :
                  <Image mode='widthFix' src={require('@/assets/img/icon7.png')} />
              }
              {
                item.score - 0 > 2 ?
                  <Image mode='widthFix' src={require('@/assets/img/icon6.png')} />
                  :
                  <Image mode='widthFix' src={require('@/assets/img/icon7.png')} />
              }
              {
                item.score - 0 > 3 ?
                  <Image mode='widthFix' src={require('@/assets/img/icon6.png')} />
                  :
                  <Image mode='widthFix' src={require('@/assets/img/icon7.png')} />
              }
              {
                item.score - 0 > 4 ?
                  <Image mode='widthFix' src={require('@/assets/img/icon6.png')} />
                  :
                  <Image mode='widthFix' src={require('@/assets/img/icon7.png')} />
              }
              <Text>￥{item.costAvg || 0}/人</Text>
            </View>
            <View className='flex-h'>
              <View className='flex-item'>
                <View>
                  <Text>{item.tags} {item.address}</Text>
                </View>
              </View>
              <Text>{this.distance(lat, lng, item.lat, item.lng)}km</Text>
            </View>
          </View>
        </View>
      </Navigator>
    )
  }
}
